#ifndef _SVM_H
#define _SVM_H

typedef signed char schar;

struct svm_problem
{
	int l;
	double *x;
};

struct svm_parameter
{
	/* these are for training only */
	double cache_size; /* in MB */
	double eps;	       /* stopping criteria */
	double C;	       /* for C_SVC, EPSILON_SVR and NU_SVR */
	int shrinking;	   /* use the shrinking heuristics */
	int maxiter;	   /* maxinum number of iterations */
};

//
// decision_function
//
struct decision_function
{
	double *alpha;
	double rho;	
	double obj;
	int    iter;
	int    chk;
};

struct decision_function solveSMO(const struct svm_problem* prob, const struct svm_parameter* param, 
		schar* y, double* b, double* C, double* alpha);

// Util func
void svm_set_print_string_function(void (*print_func)(const char *));

#endif /* _SVM_H */
